classdef GEM
    methods(Static)
        function [CCC,NewZeta,q,NewxHI59,NewxHI754,NewxHI708,Newx16,Newx11]=run(NNPP)
         %   warning('off', 'MATLAB:interp1:NaNstrip')
            warning('off','all')
            NNPP(:,3)=NNPP(:,3).*NNPP(:,1);
            NPP=GEM.Old2NewParamsVec(NNPP);
            load('negClassifier')
            load('extremaNet')
            load('pcaNet')
            NewTau=zeros(1,size(NPP,1));
            NewxHI59=zeros(1,size(NPP,1));
            NewxHI754=zeros(1,size(NPP,1));
            NewxHI708=zeros(1,size(NPP,1));
            Newx16=zeros(1,size(NPP,1));
            Newx11=zeros(1,size(NPP,1));
            NewZeta=zeros(1,size(NPP,1));
            NewX1=zeros(1,size(NPP,1));
            NewX2=zeros(1,size(NPP,1));
            NewX3=zeros(1,size(NPP,1));
            NewX4=zeros(1,size(NPP,1));
            NewY1=zeros(1,size(NPP,1));
            NewY2=zeros(1,size(NPP,1));
            NewY3=zeros(1,size(NPP,1));
            D1=zeros(4,size(NPP,1));
            D2=zeros(4,size(NPP,1));
            D3=zeros(4,size(NPP,1));
            D4=zeros(4,size(NPP,1));
            q=zeros(size(NPP,1),4);
            
            for jj=1:size(NPP,1)
%                 if NPP(jj,2)<16.5
                    peaks=ppp{1};
                    PCAcomp=PcaPca{1};
%                 elseif NPP(jj,2)>=16.5
%                     peaks=ppp{2};
%                     PCAcomp=PcaPca{2};
%                 end
                
                LogParamsZeta=NPP(jj,:); 
                LogParamsZeta([1:4 6:12])=log10(NPP(jj,[1:4 6:12])); 
                LogParamsZeta(3) = log10(1+NPP(jj,3)); 
                LogParamsZeta(9) = log10(1+NPP(jj,9)); 
                NormIntParamsZeta=LogParamsZeta; 
                for i=1:size(NPP,2) 
                    NormIntParamsZeta(:,i)=(LogParamsZeta(:,i)-peaks.paramsZeta.min(i))./(peaks.paramsZeta.max(i)-peaks.paramsZeta.min(i)); 
                end 
                NormIntParamsZeta(:,10)=0;
                NewZeta(jj)=10.^(peaks.zeta.net(NormIntParamsZeta')*(peaks.zeta.max-peaks.zeta.min)+peaks.zeta.min); 
                tauR=NPP(jj,4);
                NPP(jj,4)=NewZeta(jj); 
                NPP(jj,10)=NPP(jj,10)/tauR * NewZeta(jj);
                               
                LogParams=NPP(jj,:);
                LogParams([1:4 6:12])=log10(NPP(jj,[1:4 6:12]));
                LogParams(3) = log10(1+NPP(jj,3));
                LogParams(9) = log10(1+NPP(jj,9));
                NormIntParams=LogParams;
                for i=1:size(NPP,2)
                    NormIntParams(:,i)=(LogParams(:,i)-peaks.params.min(i))./(peaks.params.max(i)-peaks.params.min(i));
                end
                
                NewX1(jj)=10.^(peaks.x1.net(NormIntParams')*(peaks.x1.max-peaks.x1.min)+peaks.x1.min);
                NewTau(jj)=10.^(peaks.tau.net(NormIntParams')*(peaks.tau.max-peaks.tau.min)+peaks.tau.min);
                NewxHI59(jj)=-1+10.^(peaks.xHI59.net(NormIntParams')*(peaks.xHI59.max-peaks.xHI59.min)+peaks.xHI59.min);
                NewxHI754(jj)=-1+10.^(peaks.xHI754.net(NormIntParams')*(peaks.xHI754.max-peaks.xHI754.min)+peaks.xHI754.min);
                NewxHI708(jj)=-1+10.^(peaks.xHI708.net(NormIntParams')*(peaks.xHI708.max-peaks.xHI708.min)+peaks.xHI708.min);
                Newx16(jj)=10.^(peaks.x16.net(NormIntParams')*(peaks.x16.max-peaks.x16.min)+peaks.x16.min);
                Newx11(jj)=10.^(peaks.x11.net(NormIntParams')*(peaks.x11.max-peaks.x11.min)+peaks.x11.min);
                NewX2(jj)=10.^(peaks.x2.net(NormIntParams')*(peaks.x2.max-peaks.x2.min)+peaks.x2.min);
                NewX3(jj)=10.^(peaks.x3.net(NormIntParams')*(peaks.x3.max-peaks.x3.min)+peaks.x3.min);
                NewX4(jj)=10.^(peaks.x4.net(NormIntParams')*(peaks.x4.max-peaks.x4.min)+peaks.x4.min);
                NewY1(jj)=-10.^(peaks.y1.net(NormIntParams')*(peaks.y1.max-peaks.y1.min)+peaks.y1.min);
                NewY2(jj)=-10.^(peaks.y2.net(NormIntParams')*(peaks.y2.max-peaks.y2.min)+peaks.y2.min);
                NewY3(jj)=-5+10.^(peaks.y3.net(NormIntParams')*(peaks.y3.max-peaks.y3.min)+peaks.y3.min);
                NewY3(jj)=max(NewY3(jj),0);
                
                %%%% lim on min point
                Tmin=26.8*(1420.4/NewX2(jj)/10)^(1/2)*(1-(1+137)/(1420.4/NewX2(jj))); %Eq. 11 from arxiv:1609.02312
                NewY2(jj)=max(NewY2(jj),Tmin);
                
                D1(:,jj)=PCAcomp.D1.net(NormIntParams');
                D2(:,jj)=PCAcomp.D2.net(NormIntParams');
                D3(:,jj)=PCAcomp.D3.net(NormIntParams');
                D4(:,jj)=PCAcomp.D4.net(NormIntParams');
             

            end
            NewY4=zeros(size(NewY1));
            
            TTT=zeros(size(NPP,1),301);
            nunu=zeros(size(NPP,1),301);
            CCC=zeros(size(NPP,1),451);
            for cc=1:size(NPP,1)
                try
                if NewZeta(cc)>NNPP(cc,1)*40000
                    q(cc,2)=1;
%                     continue
                end
                isneg=negClassifier.predictFcn(NNPP((cc),:));
                if NewX4(cc)<NewX3(cc)
                    isneg=1;
                end
                if NewX2(cc)>NewX3(cc)
                    isneg=1;
                end
                if NewY3(cc)==0 
                    isneg=1;
                end
                NewD1=D1(:,cc)'*PCAcomp.D1.coeff'+PCAcomp.D1.mu;
                NewD2=D2(:,cc)'*PCAcomp.D2.coeff'+PCAcomp.D2.mu;
                NewD3=D3(:,cc)'*PCAcomp.D3.coeff'+PCAcomp.D3.mu;
                NewD4=D4(:,cc)'*PCAcomp.D4.coeff'+PCAcomp.D4.mu;

                xs1=0; ys1=0;
                xs2=1; ys2=-1;
                xs3=2; ys3=1;
                xs4=3; ys4=0;
                if ~isneg
                    ax1=(xs2-xs1)./(NewX2(cc)-NewX1(cc));
                    bx1=(NewX2(cc)*xs1-NewX1(cc)*xs2)./(NewX2(cc)-NewX1(cc));
                    
                    ax2=(xs3-xs2)./(NewX3(cc)-NewX2(cc));
                    bx2=(NewX3(cc)*xs2-NewX2(cc)*xs3)./(NewX3(cc)-NewX2(cc));
                    
                    ax3=(xs4-xs3)./(NewX4(cc)-NewX3(cc));
                    bx3=(NewX4(cc)*xs3-NewX3(cc)*xs4)./(NewX4(cc)-NewX3(cc));
                    
                    ay1=(ys2-ys1)./(NewY2(cc)-NewY1(cc));
                    by1=(NewY2(cc)*ys1-NewY1(cc)*ys2)./(NewY2(cc)-NewY1(cc));
                    
                    ay2=(ys3-ys2)./(NewY3(cc)-NewY2(cc));
                    by2=(NewY3(cc)*ys2-NewY2(cc)*ys3)./(NewY3(cc)-NewY2(cc));
                    
                    ay3=(ys4-ys3)./(NewY4(cc)-NewY3(cc));
                    by3=(NewY4(cc)*ys3-NewY3(cc)*ys4)./(NewY4(cc)-NewY3(cc));
                    TTT(cc,:)=[(NewD1-by1)./ay1 (NewD2(2:end-1)-by2)./ay2 (NewD3-by3)./ay3];
                    nunu(cc,:)=[([0:0.01:1]-bx1)./ax1 ([1.01:0.01:1.99]-bx2)./ax2 ([2:0.01:3]-bx3)./ax3];
                elseif isneg
                    ax1=(xs2-xs1)./(NewX2(cc)-NewX1(cc));
                    bx1=(NewX2(cc)*xs1-NewX1(cc)*xs2)./(NewX2(cc)-NewX1(cc));
                    
                    ax2=(xs4-xs2)./(NewX4(cc)-NewX2(cc));
                    bx2=(NewX4(cc)*xs2-NewX2(cc)*xs4)./(NewX4(cc)-NewX2(cc));
                    
                    ay1=(ys2-ys1)./(NewY2(cc)-NewY1(cc));
                    by1=(NewY2(cc)*ys1-NewY1(cc)*ys2)./(NewY2(cc)-NewY1(cc));
                    
                    ay2=(ys4-ys2)./(NewY4(cc)-NewY2(cc));
                    by2=(NewY4(cc)*ys2-NewY2(cc)*ys4)./(NewY4(cc)-NewY2(cc));
                    
                    TTT(cc,:)=[(NewD1-by1)./ay1 (NewD4(2:end)-by2)./ay2];
                    nunu(cc,:)=[([0:0.01:1]-bx1)./ax1 ([1.01:0.01:3]-bx2)./ax2];
                    
                end
                
                %%% interp
                CCC(cc,:)=interp1(nunu(cc,:),TTT(cc,:),1420.4./(1+[5:0.1:50]));

                %%% zeros
                indr=find(isnan(CCC(cc,:))==0,1,'first');
                if indr>1
                    CCC(cc,1:indr-1)=0;
                end
                
                zzz=[5:0.1:50];
                %%% high-z filling
                load('highz.mat');
                indh=find((1420.4/NewX1(cc)-1)<[5:0.1:50],1,'first');
                CCC(cc,indh+20:end)=highz(indh+20:end);
                CCC(cc,indh:indh+19)=interp1(zzz([indh-30:indh,indh+20:end]),CCC(cc,[indh-30:indh,indh+20:end]),zzz(indh:indh+19),'spline','extrap');
                
                % Don't go positive between high-z max and min
                indh=find((1420.4/NewX1(cc)-1)<[5:0.1:50],1,'first');
                indmin=find((1420.4/NewX2(cc)-1)<[5:0.1:50],1,'first');
                indPos=find(CCC(cc,indmin:indh)>0,1);
                if ~isempty(indPos)
                    CCC(cc,[floor((indmin+indh)/2):indh-1])=interp1(zzz([indmin:floor((indmin+indh)/2)-1 indh:indh+50]),CCC(cc,[indmin:floor((indmin+indh)/2)-1 indh:indh+50]),zzz([floor((indmin+indh)/2):indh-1]),'pchip');
                    CCC(cc,indmin:indh)=smooth(smooth(smooth(CCC(cc,indmin:indh))));
                end

                % find negative peaks after min
                if indmin>2
                    [valsPos,indsPos]=findpeaks(CCC(cc,1:indmin),'MinPeakProminence',0.1);
                    ii=indsPos(find(valsPos<0));
                    if ~isempty(ii)
                        if isneg
                            CCC(cc,round(ii/2):floor((ii+indmin)/2))=interp1(zzz([min(indr,round(ii/2)-1):max(round(ii/2)-1,indr+1) floor((ii+indmin)/2)+1:indmin]),CCC(cc,[min(indr,round(ii/2)-1):max(round(ii/2)-1,indr+1) floor((ii+indmin)/2)+1:indmin]),zzz(round(ii/2):floor((ii+indmin)/2)),'pchip');
                            CCC(cc,round(ii/2)-1:round((ii+indmin)/2)+1)=smooth(CCC(cc,round(ii/2)-1:round((ii+indmin)/2)+1));
                        else
                            CCC(cc,round((ii+indh)/2):floor((ii+indmin)/2))=interp1(zzz([min(indh,round((ii+indh)/2)-1):round((ii+indh)/2)-1 floor((ii+indmin)/2)+1:indmin]),CCC(cc,[min(indh,round((ii+indh)/2)-1):round((ii+indh)/2)-1 floor((ii+indmin)/2)+1:indmin]),zzz(round((ii+indh)/2):floor((ii+indmin)/2)),'pchip');
                            CCC(cc,round((ii+indh)/2)-1:round((ii+indmin)/2)+1)=smooth(CCC(cc,round((ii+indh)/2)-1:round((ii+indmin)/2)+1));
                        end
                    end
                end

                if any(CCC(cc,:)>0) & isneg
                    indP=find(CCC(cc,:)>0,1,'last');
                    step=min(10,indP-1);
                    CCC(cc,1:indP-step)=0;
                    CCC(cc,indP-(step-1):indP)=interp1(zzz([1:indP-step,indP+1:indP+10]),CCC(cc,[1:indP-step,indP+1:indP+10]),zzz(indP-(step-1):indP),'pchip','extrap');
                    CCC(cc,indr:indmin)=smooth(CCC(cc,indr:indmin));
                end
                
                % Don't go negative after low-z max
                if ~isneg
                    indl=find((1420.4/NewX3(cc)-1)<[5:0.1:50],1,'first');
                    indNeg=find(CCC(cc,1:indl)<0,1,'last');
                    indPos2=find(CCC(cc,1:indmin)>0,1,'last');
                    indNeg2=find(CCC(cc,1:indPos2-1)<0);
                    if ~isempty(indNeg)
                        CCC(cc,1:indNeg)=0;
                    end
                    if ~isempty(indNeg2)
                        CCC(cc,indNeg2)=0;
                    end
                end
                
                
                % Don't increase after low-z max
                if ~isneg
                    if CCC(cc,indl+5)<CCC(cc,indl)
                        CCC(cc,indr+1:indl-1)=interp1(zzz([1:indr indl:indmin]),CCC(cc,[1:indr indl:indmin]),zzz(indr+1:indl-1),'pchip');
                    end
                end
                
                % Negative derivative between min and high-z max
                indDi=find(diff(CCC(cc,indmin+1:indh-1))<-0.01,1,'first')+indmin+1;
                indDf=find(diff(CCC(cc,indmin+1:indh-1))<-0.01,1,'last')+indmin+1;
                if ~isempty(indDi)
                    if abs(indDf-indh)>abs(indDf-indmin)
                        CCC(cc,indDi:floor((indDf+indh)/2))=interp1(zzz([indmin:indDi-1 floor((indDf+indh)/2)+1:indh]),CCC(cc,[indmin:indDi-1 floor((indDf+indh)/2)+1:indh]),zzz(indDi:floor((indDf+indh)/2)),'pchip');
                    else
                        CCC(cc,floor((indDi+indmin)/2):indh)=interp1(zzz([indmin:floor((indDi+indmin)/2)-1 indDf+1:indh+20]),CCC(cc,[indmin:floor((indDi+indmin)/2)-1 indDf+1:indh+20]),zzz(floor((indDi+indmin)/2):indh),'pchip');
                    end
                end
                
                if ~isneg
                    indDi=find(diff(CCC(cc,indl+1:indmin-1))>0.01,1,'first')+indl+1;
                    indDf=find(diff(CCC(cc,indl+1:indmin-1))>0.01,1,'last')+indl+1;
                    if ~isempty(indDi)
                        if abs(indDf-indmin)>abs(indDf-indl)
                            CCC(cc,indDi:floor((indDf+indmin)/2))=interp1(zzz([indl:indDi-1 floor((indDf+indmin)/2)+1:indmin]),CCC(cc,[indl:indDi-1 floor((indDf+indmin)/2)+1:indmin]),zzz(indDi:floor((indDf+indmin)/2)),'pchip');
                        else
                            CCC(cc,floor((indDi+indl)/2):indmin)=interp1(zzz([indl:floor((indDi+indl)/2)-1 indDf+1:indmin+20]),CCC(cc,[indl:floor((indDi+indl)/2)-1 indDf+1:indmin+20]),zzz(floor((indDi+indl)/2):indmin),'pchip');
                        end
                    end
                else
                    indDi=find(diff(CCC(cc,indr+1:indmin-1))>0.01,1,'first')+indr+1;
                    indDf=find(diff(CCC(cc,indr+1:indmin-1))>0.01,1,'last')+indr+1;
                    if ~isempty(indDi)
                        if abs(indDf-indmin)>abs(indDf-indr)
                            CCC(cc,indDi:floor((indDf+indmin)/2))=interp1(zzz([indr:indDi-1 floor((indDf+indmin)/2)+1:indmin]),CCC(cc,[indr:indDi-1 floor((indDf+indmin)/2)+1:indmin]),zzz(indDi:floor((indDf+indmin)/2)),'pchip');
                        else
                            CCC(cc,floor((indDi+indr)/2):indmin)=interp1(zzz([indr:floor((indDi+indr)/2)-1 indDf+1:indmin+20]),CCC(cc,[indr:floor((indDi+indr)/2)-1 indDf+1:indmin+20]),zzz(floor((indDi+indr)/2):indmin),'pchip');
                        end
                    end
                end

                % Don't go higher than low-z max
                    if ~isneg
                        indTL=find(CCC(cc,indl:indmin)>NewY3(cc),1,'last');
                        if ~isempty(indTL)
                            CCC(cc,indl+1:indmin-1)=interp1(zzz([1:indl indmin:end]),CCC(cc,[1:indl indmin:end]),zzz(indl+1:indmin-1),'pchip');
                        end
                    end
                    
                %%% smooth
                CCC(cc,:)=smooth(smooth(smooth(CCC(cc,:))));
                catch
                    q(cc,1)=1;
                end
            end
            
            
            
            nu23=find(NNPP(:,6)>2 & NNPP(:,6)<3);
            if ~isempty(nu23)
            for i=nu23'
                a=NNPP(i,:);
                a(3)=a(3)/a(1);
                a(6)=2;
                sig2=GEM.run(a);
                a(6)=3;
                sig3=GEM.run(a);
                CCC(i,:)=interp1(([2,3]),([sig2;sig3]),NNPP(i,6));
            end
            end
            q1=GEM.Checker(CCC);
            q(q1,1)=1;
%             q(NewX4>236.73,2)=1;
%             q(NewxHI59>0.16,3)=1;
            q(Newx16>205,3)=1;
            q(Newx11<166,4)=1;
            NewxHI59=max(NewxHI59,0);
            NewxHI754=max(NewxHI754,0);
        end
        
        function NewParams=Old2NewParamsVec(Params)
            NewParams=zeros(size(Params,1),12);
            NewParams(:,1:7)=Params;
            nuMax=95;
            for i=1:size(Params,1)
                alpha=Params(i,5);
                nuMin=Params(i,6);
                nu1=1;
                nu2=2;
                if alpha==1
                    frac1=log(nuMax/nu1)/log(nuMax/nuMin);
                    frac2=log(nuMax/nu2)/log(nuMax/nuMin);
                else
                    frac1=(nuMax^(1-alpha)-nu1^(1-alpha))/(nuMax^(1-alpha)-nuMin^(1-alpha));
                    frac2=(nuMax^(1-alpha)-nu2^(1-alpha))/(nuMax^(1-alpha)-nuMin^(1-alpha));
                end
                NewParams(i,11)=frac1;
                NewParams(i,12)=frac2;
            end
            
            h = 0.6704;
            Oc = 0.12038/h^2;
            Ob = 0.022032/h^2;
            Om = Ob+Oc;
            delmax = 1.0;
            Nres = 100;
            deltas = linspace(-delmax,delmax,Nres);
            vbc = linspace(0,3.8,Nres);
            NresM = 45;
            Mass = logspace(log10(1e5),log10(1e11),NresM);
            zz=[20,15,10];
            fcoll=zeros(size(Params,1),length(zz));
            for jj=1:length(zz)
                z=zz(jj);
                if jj==2
                    deltas = linspace(-delmax,2*delmax,3*Nres/2);
                end
                Omz = Om*(1+z).^3./(Om.*(1+z).^3+1-Om);
                d = Omz-1;
                Dc = 18*pi^2+82*d-39*d^2;
                a=4.015;
                zrec = 1020;
                vbcVal=1;
                load(strcat('gridM10_',num2str(z),'.mat'));
                load(strcat('gridA10_',num2str(z),'.mat'));
%                                 M = 10^8*(Params(:,2)/23.4).^3*((1+z)/10).^(-3/2)*(Om*Dc/Omz/18/pi^2).^-0.5/h;
                Vc = (Params(:,2).^2 + (a*vbcVal*(1+z)/(1+zrec)*0.000097*3e5).^2).^0.5;
                M = 10^8*(Vc/23.4).^3*((1+z)/10).^(-3/2)*(Om*Dc/Omz/18/pi^2).^-0.5/h;
                fgasA = exp(interp3(vbc,deltas,Mass,log(gridA),vbcVal,0,M,'linear'));
                fgasM = exp(interp3(vbc,deltas,Mass,log(gridM),vbcVal,0,M,'linear'));
%                 fgasA = exp(interp3(vbc,deltas,Mass,log(gridA),0,0,M,'linear'));
%                 fgasM = exp(interp3(vbc,deltas,Mass,log(gridM),0,0,M,'linear'));
                fcoll(:,jj)=squeeze(fgasA+fgasM);
            end
            
            
            NewParams(:,8)=Params(:,1).*fcoll(:,1);
            NewParams(:,9)=Params(:,3).*fcoll(:,2);
            NewParams(:,10)=Params(:,4).*fcoll(:,3);
            
        end
        
        function q1=Checker(CCC)
            N=size(CCC,1);
            [valsPos,~]=arrayfun(@(j) findpeaks(CCC(j,:),'MinPeakProminence',0.1),1:N,'UniformOutput',0);
            [valsNeg,~]=arrayfun(@(j) findpeaks(-CCC(j,:),'MinPeakProminence',0.1),1:N,'UniformOutput',0);
            q1=[];
            for i=1:N
                if sum(valsPos{i}<0)>1 || sum(valsPos{i}>0)>1 || sum(valsPos{i}<0)==0
                    q1(end+1)=i;
                end
                if sum(valsNeg{i}<0)>0 || sum(valsNeg{i}>0)>1 || sum(valsNeg{i}>0)==0
                    q1(end+1)=i;
                end
            end
        end
    end
end
